"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ensureName = void 0;
function ensureName(hap, service, name) {
    const key = [
        `homebridge-xiaomi-roborock-vacuum`,
        `configured-name`,
        name.replaceAll(" ", "_"),
    ].join("-");
    service.addOptionalCharacteristic(hap.Characteristic.ConfiguredName);
    if (!hap.HAPStorage.storage().getItemSync(key)) {
        service.setCharacteristic(hap.Characteristic.ConfiguredName, name);
    }
    service
        .getCharacteristic(hap.Characteristic.ConfiguredName)
        .on("change", ({ newValue }) => {
        hap.HAPStorage.storage().setItemSync(key, newValue);
    });
}
exports.ensureName = ensureName;
//# sourceMappingURL=ensure_name.js.map