"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeCall = void 0;
/**
 * Calls the function `fn` if `maybeValue` is not undefined
 *
 * @param maybeValue The value that can be undefined
 * @param fn The function to be called with the value as a parameter
 */
function safeCall(maybeValue, fn) {
    if (typeof maybeValue !== "undefined") {
        fn(maybeValue);
    }
}
exports.safeCall = safeCall;
//# sourceMappingURL=safeCall.js.map